Attribute VB_Name = "Module1"
Option Explicit

Public OldWindowProc As Long

Private Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function DefWindowProc Lib "user32" Alias "DefWindowProcA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
' *********************************************
' Display message names.
' *********************************************
Public Function NewWindowProc(ByVal hwnd As Long, ByVal msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Const WM_NCPAINT = &H85
Const WM_ACTIVATE = &H6
Const WM_NCACTIVATE = &H86
Const WM_MDIACTIVATE = &H222
Const WM_SETTEXT = &HC
Const WM_SYSCOMMAND = &H112
Const SC_CLOSE = &HF060&

    ' Assume we will return True.
    NewWindowProc = True

    ' Process messages.
    Select Case msg
        Case WM_NCPAINT
            DefWindowProc hwnd, msg, wParam, lParam
            Form1.PaintActive

        Case WM_NCACTIVATE
            If wParam Then
                ' The form is active.
                DefWindowProc hwnd, msg, wParam, lParam
                Form1.PaintActive
            Else
                ' The form is inactive.
                DefWindowProc hwnd, msg, wParam, lParam
                Form1.PaintInactive
            End If

        Case WM_SETTEXT
            DefWindowProc hwnd, msg, wParam, lParam
            Form1.PaintActive

        Case WM_SYSCOMMAND
            DefWindowProc hwnd, msg, wParam, lParam
            If wParam <> SC_CLOSE Then
                Form1.PaintActive
            End If

        Case Else
            ' Invoke the original WindowProc.
            NewWindowProc = CallWindowProc( _
                OldWindowProc, hwnd, msg, wParam, _
                lParam)
    End Select
End Function
